<?php
require "../config.php";
$tblname = 'a0002';

/* handle requests */
if (isset($_GET['action'])) $_POST['action'] = $_GET['action'];
switch ($_POST['action']) {
    default:
        echo "INVALID REQUEST";
        break;
    // login
    case "signIn":  
        actionLogin($_POST['data']);
        break;
    // logout
    case "signOut":  
        actionLogout($_POST['data']);
        break;
}

function actionLogin ($d) {
    global $dbconfig, $tblname;
    $error = "";
    /* database */  
    $db = new DB($dbconfig);
    $sql = "SELECT * FROM {$tblname} WHERE name=? ";
    $stmt = $db->fetch($sql, [$d['name']]);
    if($stmt['pass']!=$d['pass']) 
        $error .= "svr-Password not correct".PHP_EOL;
    else if($stmt['emailchk']!='Y') 
        $error .= "your email not verified".PHP_EOL;
    else {
        $lastlogin = $stmt['login'];
        $sql = "UPDATE {$tblname} SET login=? WHERE name=? ";
        $db->execute($sql,[date('Y-m-d H:i:s'), $d['name']]);
        if ($db->error != "") 
            $error .= $db->error . PHP_EOL;
        else
            $_SESSION['user'] = [ 'name' => $d['name'], 'lastlogin' => $lastlogin, 'login' => date('Y-m-d H:i:s') ];
    }
    /* response */
    echo json_encode([
        "sts" => $error=="" ? "succ" : "fail",
        "err" => $error
    ]);
}

function actionLogout ($d) {
    global $dbconfig, $tblname;
    $error = "";
    /* duration */
    $login=new DateTime($_SESSION['user']['login']);    
    $logout=new DateTime(date('Y-m-d H:i:s'));
    $interval = $logout->diff($login);
    //$elapsed = $interval->format('%y years %m months %a days %h hours %i minutes %s seconds');
    $elapsed = $interval->format('%h hours %i minutes %s seconds');
    
    /* database */
    $db = new DB($dbconfig);
    $sql = "UPDATE {$tblname} SET logout=? WHERE name=? ";
    $db->execute($sql,[date('Y-m-d H:i:s'), $d['name']]);
    if ($db->error != "") 
        $error .= $db->error . PHP_EOL;
    else
        unset($_SESSION['user']);
    
    /* response */
    echo json_encode([
        "sts" => $error=="" ? "succ" : "fail",
        "err" => $error,
        "msg" => "login duration: ".$elapsed
    ]);
}
