<?php
/* A Simple DB Class 
e.g.
$conf=array(
    'host' => 'localhost',
    'dbname' => 'mydb',
    'username' => 'myuser',
    'password' => '12345678',
    'charset' => 'utf8',
);
*/
class DB {
private $conn = null;
public $error = "";
public $rowCount;
function __construct($conf) {
    // initiate by connect to db
    try {
        $str = "mysql:host=" . $conf['host'] . ";dbname=" . $conf['dbname'] . ";charset=" . $conf['charset'];
        $this->conn = new PDO($str, $conf['username'], $conf['password'], [
          PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
          PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC,
          PDO::ATTR_EMULATE_PREPARES => false
        ]);
        return true;
    }
    catch (Exception $ex) {
        print_r($ex);
        die();
    }
}
function execute($sql, $params=null) {
    // insert or update
    try {
        $stmt = $this->conn->prepare($sql);
        $stmt->execute($params);
        $this->rowCount = $stmt->rowCount();
        return true;
    }
    catch (Exception $ex) {
      $this->error = $ex->getMessage();
      return false;
    }
}
function fetchAll($sql, $params=null, $all=true) {
    // select
    try {
        $stmt = $this->conn->prepare($sql);
        $stmt->execute($params);
        $this->rowCount = $stmt->rowCount();
        if ($all)
            return $stmt->fetchAll();
        else
            return $stmt->fetch();
    }
    catch (Exception $ex) {
      $this->error = $ex->getMessage();
      return false;
    }
}
function fetch($sql, $params=null) {
    // select
    return $this->fetchAll($sql, $params, false);
}
    
} // DB class
?>
